searchData={"items":[{"type":"module","title":"Certified","doc":"The central point for calling into Certified.","ref":"Certified.html"},{"type":"function","title":"Certified.generate_transport_options/0","doc":"Generates a complete set of options for `:ssl.handshake/2`.\n\nThis uses the Thousand Island `transport_options` config defined in your\nPhoenix `Endpoint`s config, plus updated TLS keys and certs resolved\nusing the Acme config in your environment.","ref":"Certified.html#generate_transport_options/0"},{"type":"function","title":"Examples - Certified.generate_transport_options/0","doc":"iex> Certified.generate_transport_options()\n    [\n      certs_keys: [\n        %{certfile: \"mycert.pem\", keyfile: \"mykey.pem\"}\n      ]\n    ]","ref":"Certified.html#generate_transport_options/0-examples"},{"type":"type","title":"Certified.server_options/0","doc":"","ref":"Certified.html#t:server_options/0"},{"type":"module","title":"Certified.Acme.Client","doc":"An ACME client focused on a smooth integration with ACME providers.\n\nPlease note, this has only been tested against Anchor.dev\n\nMore providers coming soon.\n\nACME RFC: https://datatracker.ietf.org/doc/html/rfc8555\nJWT verifier: https://jwt.io/","ref":"Certified.Acme.Client.html"},{"type":"function","title":"Certified.Acme.Client.download_final_certificate/4","doc":"","ref":"Certified.Acme.Client.html#download_final_certificate/4"},{"type":"function","title":"Certified.Acme.Client.finalize_order/5","doc":"","ref":"Certified.Acme.Client.html#finalize_order/5"},{"type":"function","title":"Certified.Acme.Client.generate_certificate/3","doc":"","ref":"Certified.Acme.Client.html#generate_certificate/3"},{"type":"function","title":"Certified.Acme.Client.new_account/4","doc":"","ref":"Certified.Acme.Client.html#new_account/4"},{"type":"function","title":"Certified.Acme.Client.new_nonce/1","doc":"","ref":"Certified.Acme.Client.html#new_nonce/1"},{"type":"function","title":"Certified.Acme.Client.new_order/5","doc":"","ref":"Certified.Acme.Client.html#new_order/5"},{"type":"function","title":"Certified.Acme.Client.supported_provider_operations/1","doc":"","ref":"Certified.Acme.Client.html#supported_provider_operations/1"},{"type":"module","title":"Certified.CertificateUpdateListener","doc":"","ref":"Certified.CertificateUpdateListener.html"},{"type":"function","title":"Certified.CertificateUpdateListener.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Certified.CertificateUpdateListener.html#child_spec/1"},{"type":"function","title":"Certified.CertificateUpdateListener.start_link/1","doc":"","ref":"Certified.CertificateUpdateListener.html#start_link/1"},{"type":"module","title":"Certified.CertificateUpdateListener.State","doc":"","ref":"Certified.CertificateUpdateListener.State.html"},{"type":"type","title":"Certified.CertificateUpdateListener.State.t/0","doc":"","ref":"Certified.CertificateUpdateListener.State.html#t:t/0"},{"type":"module","title":"Certified.CertificateUpdater","doc":"","ref":"Certified.CertificateUpdater.html"},{"type":"function","title":"Certified.CertificateUpdater.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Certified.CertificateUpdater.html#child_spec/1"},{"type":"function","title":"Certified.CertificateUpdater.start_link/0","doc":"","ref":"Certified.CertificateUpdater.html#start_link/0"},{"type":"module","title":"Certified.CertificateUpdater.State","doc":"","ref":"Certified.CertificateUpdater.State.html"},{"type":"type","title":"Certified.CertificateUpdater.State.t/0","doc":"","ref":"Certified.CertificateUpdater.State.html#t:t/0"},{"type":"module","title":"Certified.CertificateUpdaterRegistration","doc":"","ref":"Certified.CertificateUpdaterRegistration.html"},{"type":"function","title":"Certified.CertificateUpdaterRegistration.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Certified.CertificateUpdaterRegistration.html#child_spec/1"},{"type":"function","title":"Certified.CertificateUpdaterRegistration.start_link/1","doc":"","ref":"Certified.CertificateUpdaterRegistration.html#start_link/1"},{"type":"module","title":"Certified.SSLTransport","doc":"A thin wrapper around the SSL transport used by Thousand Island.\n\nThis allows Certified to hook into the SSL handshake event, giving us\nthe ability to update the SSL certificates used by `:ssl.handshake/2`\n\nhttps://hexdocs.pm/thousand_island/ThousandIsland.Transports.SSL.html","ref":"Certified.SSLTransport.html"},{"type":"module","title":"Certified.Supervisor","doc":"","ref":"Certified.Supervisor.html"},{"type":"function","title":"Certified.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Certified.Supervisor.html#child_spec/1"},{"type":"function","title":"Certified.Supervisor.start_link/1","doc":"","ref":"Certified.Supervisor.html#start_link/1"},{"type":"extras","title":"Certified - ACME for the modern Elixir stack","doc":"# Certified - ACME for the modern Elixir stack\n\nPhoenix + Bandit + ACME, built for distributed deployments.\n\nCertified is built for distributed Phoenix apps that are using Bandit and Thousand Island.\nThis stack allows Certified to hook into the `:ssl.handshake` function call and inject updated\ncertificates and their private keys. This approach also supports multiple certificates\nand keys to be passed along.\n\nA singular `CertificateUpdater` per cluster, orchestrated by `ProcessHub`, is in charge of\nrequesting the certificates (if they aren't available on another node), and renewing them\nwhen they have only 25% of their validity left.\n\nAnd with the power of `Phoenix.PubSub`, your nodes can sync their certificates without the\nneed to have shared storage. This also works smoothly when new nodes come online as they\nannounce their presence and ask for the certificates and keys from the running `CertificateUpdater`.\n\n**Important**\n\nThis integration has been developed for use with Anchor.dev, which takes care of\nACME challenges for you. Future releases will support other ACME providers and support HTTP\nchallenges.","ref":"readme.html"},{"type":"extras","title":"Installation - Certified - ACME for the modern Elixir stack","doc":"```elixir\ndef deps do\n  [\n    {:certified, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configure - Certified - ACME for the modern Elixir stack","doc":"In your config, usually `config/runtime.exs`, change your `Endpoint` to use the\nincluded `Certified.SSLTransport` transport, as well as a self-signed key and cert to use on boot.\n\nThese settings are added to the `thousand_island_options` of your `Endpoint` config:\n\n```elixir\nconfig :my_app, MyApp.Endpoint,\n  url: [host: \"myhost.com\"],\n  https: [\n    port: 4040,\n    otp_app: :my_app,\n    thousand_island_options: [\n      # How we hook into the `:ssl.handshake` flow\n      transport_module: Certified.SSLTransport,\n      transport_options: [\n        # Some self signed certs to use on application startup\n        certs_keys: [%{certfile: \"cert.pem\", keyfile: \"key.pem\"}]\n      ]\n    ]\n  ]\n```\n\nAnd then all you need to do is to configure Certified with your ACME details.\n\n```elixir\nconfig :certified,\n  domains: System.get_env(\"ACME_DOMAINS\"),\n  acme: [\n    directory_url: System.get_env(\"ACME_DIRECTORY_URL\"),\n    eab: [\n      kid: System.get_env(\"ACME_EAB_KID\"),\n      hmac_key: System.get_env(\"ACME_EAB_HMAC_KEY\")\n    ]\n  ]\n```","ref":"readme.html#configure"},{"type":"extras","title":"Upcoming improvements - Certified - ACME for the modern Elixir stack","doc":"- Docs docs docs, and examples\n- Storage adapters for the EC key and certs (File system and S3)\n- HTTP challenges (https://github.com/mtrudel/bandit?tab=readme-ov-file#using-bandit-with-plug-applications)\n- Don't require EAB tokens\n- Full testing against LetsEncrypt and ZeroSSL\n- Support earlier Elixir versions? (switch to Jason or at least allow it to be used)","ref":"readme.html#upcoming-improvements"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.1.0 - 2025-02-18 - Changelog","doc":"Initial release","ref":"changelog.html#v0-1-0-2025-02-18"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.1"}}